# SuperFastPython.com
# example of creating a process pool and executing a task
from time import sleep
from concurrent.futures import ProcessPoolExecutor

# task function to be executed in the process pool
def task():
    # report a message
    print(f'Task executing', flush=True)
    # block for a moment
    sleep(1)
    # report a message
    print(f'Task done', flush=True)

# protect the entry point
if __name__ == '__main__':
    # create and configure the process pool
    with ProcessPoolExecutor() as exe:
        # issue tasks to the process pool
        exe.submit(task)
    # process pool is closed automatically
