# SuperFastPython.com
# example of issuing a task asynchronously to the process pool
from time import sleep
from concurrent.futures import ProcessPoolExecutor

# task function to be executed in the process pool
def task():
    # report a message
    print(f'Task executing', flush=True)
    # block for a moment
    sleep(1)
    # return a result
    return 'All Done'

# protect the entry point
if __name__ == '__main__':
    # create and configure the process pool
    with ProcessPoolExecutor() as exe:
        # issue tasks to the process pool
        future = exe.submit(task)
        # wait for the result
        print('Waiting for result...')
        result = future.result()
        # report the result
        print(result)

