# SuperFastPython.com
# example of waiting for all tasks to complete
from time import sleep
from concurrent.futures import ProcessPoolExecutor
from concurrent.futures import wait

# task function to be executed in the process pool
def task(value):
    # sleep for a moment
    sleep(1)
    # report a message
    print(f'Done: {value}', flush=True)

# protect the entry point
if __name__ == '__main__':
    # start the process pool
    with ProcessPoolExecutor(2) as exe:
        # submit tasks and collect futures
        futures = [exe.submit(task, i) for i in range(10)]
        # wait for all tasks to complete
        print('Waiting for tasks to complete...')
        wait(futures)
        print('All tasks are done!')